﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using Microsoft.WindowsAzure;
using Microsoft.WindowsAzure.StorageClient;

namespace ExampleMvcWebRole.Controllers
{
    [HandleError]
    public class HomeController : Controller
    {
        public ActionResult Index()
        {
            ViewData["Message"] = "Welcome to ASP.NET MVC!";

            return View();
        }

        [HttpPost]
        public ActionResult UploadFile(HttpPostedFileBase uploadedFile)
        {
            try
            {
                // Setup the connection to Windows Azure Storage
                var storageAccount = CloudStorageAccount.FromConfigurationSetting("DataConnectionString");
                var _BlobClient = storageAccount.CreateCloudBlobClient();

                // Get and create the container
                var _BlobContainer = _BlobClient.GetContainerReference("uploadedfiles");
                _BlobContainer.CreateIfNotExist();

                // Setup the permissions on the container to be public
                var permissions = new BlobContainerPermissions();
                permissions.PublicAccess = BlobContainerPublicAccessType.Container;
                _BlobContainer.SetPermissions(permissions);

                // Write the uploaded file to blob storage
                var blob = _BlobContainer.GetBlobReference(uploadedFile.FileName);
                blob.UploadFromStream(uploadedFile.InputStream);
                blob.Properties.ContentType = uploadedFile.ContentType;
                blob.SetProperties();
            
                ViewData["Message"] = "Your file has been uploaded to blob storage";
                ViewData["FileUri"] = blob.Uri;
            }
            catch (Exception)
            {
                ViewData["Message"] = "There was a problem uploading your file";
            }

            return View("Index");
        }

        public ActionResult About()
        {
            return View();
        }
    }
}
